from torch import negative, positive
from transformers import BertTokenizer, BertForSequenceClassification
from transformers import pipeline
import matplotlib.pyplot as plt
import pandas as pd
import datetime
import numpy as np

#download finbert and tokenizer 
finbert = BertForSequenceClassification.from_pretrained('yiyanghkust/finbert-tone', num_labels=3)
tokenizer = BertTokenizer.from_pretrained('yiyanghkust/finbert-tone')

#apply finbert model to the pipeline
nlp = pipeline("sentiment-analysis", model=finbert, tokenizer=tokenizer)

def process_ticker_headlines(ticker):
    '''
    Function which takes in a stock ticker, loads its headlines from the text file generated from headline_scrape.py, and performs sentiment analysis with the pre-trained FinBERT model. 
    Outputs headline, date, score to a csv file.
    ticker - string
    method - string 
    returns nothing
    '''
    #similar to headline_scrape function, but use finbert to perform analysis.
    ticker_name = ticker
    if ticker.endswith('.txt') == False:
        ticker = ticker + '.txt'
    headline_collection = []
    count = 0
    with open('headlines/' + ticker, 'r') as f:
        headlines = f.readlines()
        end = len(headlines)
        for headline in headlines:
            percentage = count / end
            percentage = round(percentage * 100, 1)
            count = count + 1
            print("Progress: " + str(percentage) + "%", end="\r")
            headline_string = headline.split(" ", 2)
            sentiment_value = nlp(headline_string[2])
            headline_collection.append([headline_string[0], headline_string[2], sentiment_value])
    df = pd.DataFrame(headline_collection, columns=['Date', 'Headline', 'Sentiment Score'])
    df.to_csv('sentiment/' + ticker_name + '_finbert_data.csv')

def display_ticker_data(ticker):
    '''
    Function which takes in a stock ticker, calculates the weekly average polarity for both VADER and TextBlob, plots it to a graph, and calculates the PMCC for the whole dataset.
    process_ticker_headlines must be called before this otherwise it won't work, as it reads in the csv file generated by that function.
    ticker - string
    '''
    print(ticker)
    #load finbert spreadsheet
    finbert_sentiment_csv = 'sentiment/' + ticker + '_finbert_data.csv'
    df_finbert = pd.read_csv(finbert_sentiment_csv)
    finbert_dates = df_finbert.loc[:, "Date"]

    #variables to track when calculating weekly average
    positive_score = 0
    negative_score = 0
    current_week_number = 0
    weekly_dates = []

    weekly_positive_scores = []
    weekly_negative_scores = []
    count = 0

    running_datetime = datetime.datetime(2021, 4, 5)
    #get every weekly date for the graph plot
    for i in range(45):
        weekly_dates.append(running_datetime.strftime("%d/%m"))
        running_datetime = running_datetime + datetime.timedelta(days=7)
    for i in range(len(finbert_dates)): 
        #display progress
        percentage = count / (len(finbert_dates) - 1) 
        percentage = round(percentage * 100, 1)
        count = count + 1
        print("Progress: " + str(percentage) + "%", end="\r")
        
        #get date and check if it is in the current week
        date = df_finbert.loc[i, "Date"]
        date = date.split("/") 
        if(int(date[2]) < 1000):
            date[2] = "20" + date[2]
        week_datetime = datetime.date(int(date[2]), int(date[1]), int(date[0]))
        week_number = week_datetime.isocalendar()[1]
        if i == 0:
            current_week_number = datetime.datetime(2021, 4, 5).isocalendar()[1]
            score = df_finbert["Sentiment Score"][i]
            #check if label is postive neutral or negative
            if score[12] == 'p':
                positive_score += 1
            else:
                if score[14] == 'u':
                    pass #ignore neutral scores
                else:
                    negative_score += 1
            
        else:
            #if it is not in the current week, reset all values and calculate positive and negative proportion for
            #the week
            if week_number != current_week_number:
                if week_number != 1:
                    if week_number < current_week_number:
                        continue
                total = positive_score + negative_score
                if total == 0:
                    weekly_positive_scores.append(0)
                    weekly_negative_scores.append(0)
                else:
                    weekly_positive_scores.append(positive_score / total)
                    weekly_negative_scores.append(-(negative_score / total))
                positive_score = 0
                negative_score = 0
                for i in range(week_number - current_week_number - 1):
                    #if there is a week with no data then append 0
                    weekly_positive_scores.append(0)
                    weekly_negative_scores.append(0)
                current_week_number = week_number

            #add on scores to positive/negative/neutral counter
            score = df_finbert["Sentiment Score"][i]
            #check if label is postive neutral or negative
            if score[12] == 'p':
                positive_score += 1
            else:
                if score[14] == 'u':
                    pass
                else:
                    negative_score += 1

            #calculte average if it is the last total
            if i == len(finbert_dates) - 1:
                total = positive_score + negative_score
                if(total == 0):
                    weekly_positive_scores.append(0)
                    weekly_negative_scores.append(0)
                else:
                    weekly_positive_scores.append(positive_score / total)
                    weekly_negative_scores.append(-(negative_score / total))
                for i in range(week_number - current_week_number - 1):
                    #if there is a week with no data then append 0
                    weekly_positive_scores.append(0)
                    weekly_negative_scores.append(0)
    
    #set matplotlib size
    plt.rcParams["figure.figsize"] = (16,12)

    #print correlation coefficient
    stock_data = get_stock_data(ticker)
    print('Correlation Coefficient: ' + str(np.corrcoef(weekly_positive_scores, stock_data)[0][1]))


    plt.figure()
    plt.title(ticker + ' - Sentiment (FinBERT)')
    plt.xlabel('Date')
    plt.ylabel('Normalised Values')
    plt.xticks(rotation = 90)
    plt.bar(weekly_dates, weekly_positive_scores, label='Positive Sentiment (Normalised)', color='lightgreen')
    plt.bar(weekly_dates, weekly_negative_scores, label='Negative Sentiment (Normalised)', color='lightcoral')
    plt.plot(weekly_dates, stock_data, label='Stock Price (Normalised)', color='orange')
    plt.legend()

    plt.savefig('sentiment_pictures/' + ticker + '_finbert.png')



def get_stock_data(ticker):
    ''''
    Function which takes in a stock ticker and retrieves an array of its closing values from a spreadsheet.
    ticker - string
    returns an array of integers
    '''
    #get stock data and normalise the values
    ticker = 'stock_prices/' + ticker
    if ticker.endswith('.csv') == False:
        ticker = ticker + '.csv' 
    df = pd.read_csv(ticker)
    weekly_closes = df.loc[:, "Close"]
    max_value = weekly_closes.max()
    min_value = weekly_closes.min()
    normalised_stock_values = []
    for i in range(len(weekly_closes)):
        normalised = (weekly_closes[i] - min_value) / (max_value - min_value)
        normalised = (normalised * 2) - 1
        normalised_stock_values.append(normalised)
    return normalised_stock_values

companies = ['AAPL', 'AMZN', 'BHP', 'BRK.A', 'GOOG', 'JNJ', 'NEE', 'PLD', 'UPS', 'WMT', 'XOM']               

for company in companies:
    display_ticker_data(company)